;
; Holy KNIGHT BIOS for P6
;

	relaxed on

;
; 荞݃xN^
;
	org	$b000

INT_TABLE:
	dw	INTDT0		; 0x00
	dw	INTKEYIN	; 0x02iKEYINPUTj
	dw	INTDT0		; 0x04iRS-232Cj
	dw	INTTIMER	; 0x06iTIMERj
	dw	INTDT1		; 0x08iCMT READj
	dw	INTDT0		; 0x0A
	dw	INTDT0		; 0x0C
	dw	INTDT1		; 0x0EiL[́j
	dw	INTDT1		; 0x10iL[́j
	dw	INTDT0		; 0x12iCMT ERRORj
	dw	INTKEYIN2	; 0x14iL[́j
	dw	INTGAMEKEY	; 0x16iQ[L[́j
	dw	INTDT0		; 0x18iTVRj
	dw	INTDT0		; 0x1AiTIME֘Aj
	dw	INTDT1		; 0x1CiTIME֘Aj
	dw	INTDT0		; 0x1E
	dw	INTDT0		; 0x20iVOICEj
	dw	INTVSYNC	; 0x22iVSYNCj

;
; Wve[u
;
	org	$b030

	jp	INIT		; 0xb030	// ݒ
	jp	PCG_OFF		; 0xb033	// ݒ
	jp	PCG_ON		; 0xb036	// ݒ
	jp	INKEY		; 0xb039	// L[
	jp	GAMEKEY		; 0xb03c	// Q[L[
	jp	BEEP_ON		; 0xb03f	// BEEP ON
	jp	BEEP_OFF	; 0xb042	// BEEP OFF
	jp	BEEP_BOMB	; 0xb045	// BEEP BOMB
	jp	PUTKANA		; 0xb048	// Jio


	org	$b050

GAMEDATA:
	db	$00		; 0xb050FQ[L[̓obt@
KEYDATA:
	db	$00		; 0xb051FQ[L[̗オ茟o
PCG_DRAW:
	db	$ff		; 0xb052FPCG\tO
KANA_DRAW:
	db	$00		; 0xb053FJi\tO
BEEP_FRQ:
	dw	$0000		; 0xb054FBEEPg
RND_WORK:
	dw	$0000		; 0xb056Fp[N
SUB_WORK_HL:
	dw	$0000		; 0xb058FTu[`R[p[N
SUB_WORK_BC:
	dw	$0000		; 0xb05aFTu[`R[p[N
SUB_WORK_DE:
	dw	$0000		; 0xb05cFTu[`R[p[N
SUB_WORK_AF:
	dw	$0000		; 0xb05eFTu[`R[p[N


;
; TuCPUPoCgf[^M
;
; RETFAreg=Mf[^
;
GETSUBCPU:
	ld	a,$0c
	out	($93),a
.wait:
	in	a,($92)
	and	$20
	jr	z,.wait
	ld	a,$0d
	out	($93),a
	in	a,($90)
	ret

;
; TuCPUւPoCgf[^𑗐M
;
; Areg=Mf[^
;
SETSUBCPU:
	push	af
	ld	a,$08
	out	($93),a
.wait:
	in	a,($92)
	and	$80
	jr	z,.wait
	ld	a,$09
	out	($93),a
	pop	af
	out	($90),a
	ret

;
; 荞ݏI[if[^PoCgM{Ȃj
;
INTDT1:
INTKEYIN:
INTKEYIN2:
	push	af
	call	GETSUBCPU
	pop	af

; 荞ݏI[iȂj
;
INTDT0:
INTVSYNC:
	ei
	ret

;
; ^C}荞
;
INTTIMER:
	push	af

	ld	a,(TIMERCNT)
	inc	a
	and	$07
	ld	(TIMERCNT),a
	jr	nz,.next1

	ld	a,$06
	call	SETSUBCPU	; Q[L[Ăяo

.next1:
;	ld	a,(KEYCNT)
;	inc	a
;	and	$ff
;	ld	(KEYCNT),a
;	jr	nz,.end
;	xor	a
;	ld	(KEYDATA),a	; ^C}AL[obt@NA

	ld	a,(BEEPCNT)
	or	a
	jr	z,.end
	dec	a
	ld	(BEEPCNT),a
.end:
	pop	af
	ei
	ret

TIMERCNT:
	db	$00

BEEPCNT:
	db	$00

;
; Q[L[荞
;
INTGAMEKEY:
	push	af
	push	bc

	call	GETSUBCPU

		;
		; TuCPŨQ[L[JOYSTICK̕тɕύX
		; SPC "0" E STOP SFT
		;  
		; "0" STOP SFT SPC E

	ld	b,a
	xor	a
	bit	2,b
	jr	z,.lp1
	or	$01
.lp1:	bit	3,b
	jr	z,.lp2
	or	$02
.lp2:	bit	5,b
	jr	z,.lp3
	or	$04
.lp3:	bit	4,b
	jr	z,.lp4
	or	$08
.lp4:	bit	7,b
	jr	z,.lp5
	or	$10
.lp5:	bit	0,b
	jr	z,.lp6
	or	$20
.lp6:	bit	1,b
	jr	z,.lp7
	or	$40
.lp7:
	ld	b,a

		;
		; WCXeBbN|[gɃANZX
		;
	ld	a,$0f
	out	($a0),a
	ld	a,$c0
	out	($a1),a
	ld	a,$0e
	out	($a0),a
	in	a,($a2)
	cpl
	and	$3f
		;
		; AregF"0" "0" TRG2 TRG1 E

	or	b
	ld	b,a		; Q[L[́ij

	ld	a,(GAMEDATA)
	cpl
	ld	c,a		; Q[L[́iO̔]j

	ld	a,b
	ld	(GAMEDATA),a	; ̕

	and	c
	ld	(KEYDATA),a	; オ

	pop	bc
	pop	af
	ei
	ret


;
; ݒ
;
INIT:

		; 荞ݐݒ
		;
	im	2
	ld	a,$b0
	ld	i,a

		; PSGݒ
		;
	ld	a,$08
	out	($a0),a
	ld	a,$00		; `lẢʂOɂ
	out	($a1),a
	ld	a,$09
	out	($a0),a
	ld	a,$00		; `lB̉ʂOɂ
	out	($a1),a
	ld	a,$0a
	out	($a0),a
	ld	a,$00		; `lC̉ʂOɂ
	out	($a1),a
	ld	a,$07
	out	($a0),a
	ld	a,$b8		; `lA/B/C̃g[o͂
	out	($a1),a

		; 0x0000-0x1fff̓ǂݏORAMɂ
		;
	ld	a,$20
	out	($60),a
	out	($68),a

		; 0xc000-0xffff݂̏ORAMɂ
		;
	ld	a,$2c
	out	($6e),a
	add	a,2
	out	($6f),a

		; yf[^]
		;
	ld	hl,$c900
	ld	de,$c900
	ld	bc,$0400
	ldir

		; 0xc000-0xffff̓ǂݏoORAMɂ
		;
	ld	a,$2c
	out	($66),a
	add	a,2
	out	($67),a

	ld	a,$c3
	ld	($0000),a
	ld	hl,MEMHL_E
	ld	($0001),hl	; rst 0x00FMEMHL_E

	ld	($0008),a
	ld	hl,MEMHL_E_ATT
	ld	($0009),hl	; rst 0x08FMEMHL_E_ATT

	ld	($0010),a
	ld	hl,MEMHL_E_BLUE
	ld	($0011),hl	; rst 0x10FMEMHL_E_BLUE

	ld	($0018),a
	ld	hl,MEMHL_E_READ
	ld	($0019),hl	; rst 0x18FMEMHL_E_READ

	ld	($0020),a
	ld	hl,MEMHL_E_B_RED
	ld	($0021),hl	; rst 0x20FMEMHL_E_B_RED

	ld	($0028),a
	ld	hl,BANK_C0_E0
	ld	($0029),hl	; rst 0x28FBANK_C0_E0

	ld	($0030),a
	ld	hl,PSGOUT
	ld	($0031),hl	; rst 0x30FPSGOUT

	ld	($0038),a
	ld	hl,$0038
	ld	($0039),hl	; oOgbv


		; 0x0000-0x1fff݂̏RAM(VRAM)ɂ
		;
	ld	a,$00
	out	($68),a

	ld	a,$ff
	ld	(PCG_DRAW),a

	ld	a,$00
	ld	(KANA_DRAW),a

	ld	a,$00
	ld	(GAMEDATA),a

	ld	a,$00
	ld	(BEEPCNT),a

	ei

	ld	hl,.init_dat1
	ld	de,$ca46
	ld	bc,.init_dat1_e - .init_dat1
	ldir

	ld	hl,.init_dat2
	ld	de,$ccb4
	ld	bc,.init_dat2_e - .init_dat2
	ldir

	jp	$2c00

.init_dat1:
	db	$1b,$0c,$18,$09,$19,$03,$1b,$0c,$14,$0c,$16,$03,$18,$03,$19,$03
	db	$1b,$03,$19,$06,$18,$06,$16,$18,$18,$03,$19,$03,$1b,$03,$1d,$03
	db	$1b,$06,$1b,$06,$20,$0c,$1b,$0c,$19,$06,$18,$03,$19,$03,$16,$09
	db	$14,$03,$14,$18,$18,$03,$16,$03,$18,$03,$19,$03,$18,$06,$18,$06
	db	$16,$0c,$14,$0c,$19,$06,$18,$06,$16,$06,$14,$06,$13,$12,$13,$06
	db	$14,$03,$13,$03,$14,$03,$16,$03,$14,$06,$14,$06,$1d,$0c,$1a,$0c
	db	$1b,$06,$1d,$03,$1b,$03,$1a,$09,$1b,$03,$1b,$18,$1b,$0c,$18,$09
	db	$19,$03,$1b,$12,$14,$06,$16,$03,$18,$03,$19,$03,$1b,$03,$19,$06
	db	$18,$06,$16,$12,$17,$06,$18,$03,$19,$03,$1b,$03,$1d,$03,$1b,$06
	db	$1b,$06,$20,$0c,$1b,$0c,$19,$06,$18,$03,$19,$03,$16,$09,$14,$03
	db	$14,$18,$ff,$ff
.init_dat1_e:


.init_dat2:
	db	$14,$0c,$08,$0c,$14,$0c,$0c,$0c,$0f,$0c,$0f,$06,$0f,$06,$0f,$18
	db	$08,$0c,$14,$06,$14,$06,$19,$0c,$14,$0c,$13,$06,$14,$06,$0f,$06
	db	$0d,$06,$03,$18,$14,$06,$13,$06,$14,$06,$11,$06,$13,$06,$10,$06
	db	$11,$06,$0d,$06,$0a,$12,$0a,$06,$0c,$06,$0a,$06,$08,$06,$07,$06
	db	$05,$12,$0f,$06,$0e,$0c,$0a,$0c,$0c,$06,$08,$06,$0a,$06,$0a,$06
	db	$03,$18,$08,$0c,$30,$0c,$08,$12,$0c,$06,$0f,$09,$08,$03,$07,$06
	db	$08,$06,$03,$18,$08,$0c,$0f,$06,$0f,$06,$0f,$0c,$0f,$0c,$0f,$06
	db	$0f,$06,$0f,$06,$0d,$06,$08,$18,$ff,$ff
.init_dat2_e:

;
; BEEP炷
;
; 894.88625kHz (BEEP_FRQ)ŕ
;
; F_m7 = 894886.25 / n
;
; P6
; F_p61996750 / (16 x m)
;
; 1996750 / (16 x m) = 894886.25 / n
; 1996750 x n = 894886.25 x 16 x m
; m = 1996750 x n / 894886.25 x 16
; m = 1996750 x n / 894886.25 / 16
; m = 0.13946 x n
;
BEEP_ON:
	ld	a,(BEEPCNT)
	or	a
	ret	nz

	push	de
	push	hl

	ld	hl,(BEEP_FRQ)

		; /1   = hl*1
		; /2   = hl*0.5
		; /4   = hl*0.25
		; /8   = hl*0.125
		; /16  = hl*0.0625
		; /32  = hl*0.03125
		; /64  = hl*0.015625

	srl	h
	rr	l		; /2
	srl	h
	rr	l		; /4
	srl	h
	rr	l		; /8

	ld	e,l
	ld	d,h

	srl	h
	rr	l		; /16
	srl	h
	rr	l		; /32
	srl	h
	rr	l		; /64

	add	hl,de

	di

	ld	a,5
	ld	(BEEPCNT),a

	ld	a,$04		; ʂWrbg
	out	($a0),a
	ld	a,l
	out	($a1),a
	ld	a,$05		; ʂSrbg
	out	($a0),a
	ld	a,h
	out	($a1),a

	ld	a,$07
	out	($a0),a
	ld	a,$b8		; `lA/B/C̃g[o͂
	out	($a1),a

	ld	a,$0a
	out	($a0),a
	ld	a,$0f		; `lC̉ʂ15ɂ
	out	($a1),a

	ei

	pop	hl
	pop	de
	ret

;
; j󉹂o
;
BEEP_BOMB:
	di
	ld	a,$06		; mCYg
	out	($a0),a
	ld	a,5
	out	($a1),a
	ld	a,$0b		; Gx[vg
	out	($a0),a
	ld	a,0
	out	($a1),a
	ld	a,$0c		; Gx[vg
	out	($a0),a
	ld	a,20
	out	($a1),a

	ld	a,$07
	out	($a0),a
	ld	a,$9f		; `lCFmCYo͂
	out	($a1),a

	ld	a,$0a
	out	($a0),a
	ld	a,$10		; `lC̉ʂGx[vɂ
	out	($a1),a

	ld	a,$0d		; Gx[vg`
	out	($a0),a
	ld	a,0
	out	($a1),a

	ei
	ret

;
; BEEP~߂
;
BEEP_OFF:
	di
	ld	a,$04		; ʂWrbg
	out	($a0),a
	ld	a,$00
	out	($a1),a
	ld	a,$05		; ʂSrbg
	out	($a0),a
	ld	a,$00
	out	($a1),a

	ld	a,$07
	out	($a0),a
	ld	a,$b8		; `lA/B/C̃g[o͂
	out	($a1),a

	ld	a,$0a
	out	($a0),a
	ld	a,$00		; `lC̉ʂOɂ
	out	($a1),a
	ei
	ret

;
; PSG֏o͂
; AFo̓f[^
;
PSGOUT:
	cp	$ff
	jr	nz,.lp1

		; ݒl0xffA~
		;
.off:
	di
	ld	a,$07
	out	($a0),a
	ld	a,$b8		; `lA/B/C̃g[o͂
	out	($a1),a
	ld	a,$08
	out	($a0),a
	ld	a,$00		; `lẢʂOɂ
	out	($a1),a
	ld	a,$09
	out	($a0),a
	ld	a,$00		; `lB̉ʂOɂ
	out	($a1),a
	ei
	ret

.lp1:
	bit	7,a
	jr	z,.lp2

		; bit7=1APoCg
		;
	bit	4,a
	jr	nz,.lp3

		; bit4=0AgʂSrbg
		;
	ld	(.befdat),a
	ret

.lp3:
		; bit4=1Aʐݒ
		;
	di
	push	af
	and	$20		; 0=`lA/1=`lB
	rlca
	rlca
	rlca
	or	$08
	out	($a0),a		; `lA/B̉
	pop	af
	cpl
	and	$0f
	out	($a1),a
	ei
	ret

.lp2:
		; bit7=0AQoCg
		;
	push	bc

	sla	a		; x2
	ld	b,a		; gʂWrbg

	ld	a,(.befdat)
	and	$20		; 0=`lA/1=`lB
	rlca
	rlca
	rlca
	rlca
	ld	c,a

	di
	ld	a,$07
	out	($a0),a
	ld	a,$b8		; `lA/B/C̃g[o͂
	out	($a1),a

	ld	a,c
	out	($a0),a		; `lA/B̎g
	ld	a,b
	out	($a1),a		; gʂWrbg
	ld	a,c
	inc	a
	out	($a0),a		; `lA/B̎g
	ld	a,(.befdat)
	and	$0f
	out	($a1),a		; gʂSrbg
	ei

	pop	bc
	ret

.befdat:
	db	$00

;
; 0xc000-0xffff̓ǂݏo؂ւ
;
BANK_C0_E0:
	ex	(sp),hl
	ld	a,(hl)
	inc	hl
	ex	(sp),hl
	out	($66),a
	add	a,2
	out	($67),a
	ret

;
; PCGɏłAʂɔfȂ
;
PCG_OFF:
	xor	a
	ld	(PCG_DRAW),a
	ret

;
; PCGɏނƁAʂɔf
;
PCG_ON:
	ld	a,$ff
	ld	(PCG_DRAW),a
	ret

;
; PCG݁\itOɏ]j
; LD (HL),E
;
MEMHL_E:
	ld	(hl),e
	push	af

	ld	a,(PCG_DRAW)
	or	a
	call	nz,Draw_8x8

	pop	af
	ret

;
; PCG-ATT݁\itOɏ]j
; LD (HL),E
;
MEMHL_E_ATT:
	ld	(hl),e
	push	af
	push	hl

	res	3,h

	ld	a,(PCG_DRAW)
	or	a
	call	nz,Draw_8x8

	pop	hl
	pop	af
	ret

;
; PCG̓eǂݍŁA\
; LD (HL),E
;
MEMHL_E_READ:
	ld	(hl),e
	push	hl

	set	2,h
	call	Draw_8x8

	pop	hl
	ret

;
;  PCG-VRAM̓ewiԐFŕ\
; LD (HL),E
;
MEMHL_E_B_RED:
	ld	(hl),e

	call	Draw_8x8x3_red

	ret

;
; tO𖳎āAx^\
; LD (HL),E
;
MEMHL_E_BLUE:
	ld	(hl),e

	push	af
	push	bc
	push	de
	push	hl

	ld	b,$09		; 
	jp	Erase_8x8	; 󔒂`

;
; 8x8L\
;
; HLFVRAMAhXi0xd400`0xd7ff / 0xd000`0xd3ffj
;
Draw_8x8:
	push	af
	push	bc
	push	de
	push	hl

	ld	a,(hl)
	ld	b,$08		; 
	or	a
	jp	z,Erase_8x8	; LN^F0x00Ȃ󔒂`

	push	hl		; VRAMAhX

	ld	e,a
	set	3,h
	ld	a,(hl)

	bit	3,a
	jr	nz,.lp1
	pop	hl
	jp	Erase_8x8

.lp1:
	and	$40
	rlca
	rlca
	ld	d,a
	ex	de,hl

	add	hl,hl	; x2
	add	hl,hl	; x4
	add	hl,hl	; x8
	add	hl,hl	; x16
	add	hl,hl	; x32
	ld	de,$4000
	add	hl,de	; HLFLN^AhXi0x4000`j

	pop	de	; VRAMAhX

;
; 8x8x3v[L\
;
; HLFLN^f[^AhX
; DEFVRAMAhXi0xd400`0xd7ffj
;
Draw_8x8x3:
	push	hl
	call	CALC_XY
	pop	hl

	ld	a,$08		; 0x4000-0x7fff̓ǂݏoRAM0x8000-0xbfff
	out	($62),a
	add	a,2
	out	($63),a

	ld	b,8
	ld	(.xpos+1),de
.lp1:
.xpos:	ld	de,$0000
	ld	a,c
	out	($ce),a

	REPT	3
	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	e
	rlca
	rlca
	rlca
	rlca
	ld	(de),a
	inc	e
	ENDM

	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	e
	rlca
	rlca
	rlca
	rlca
	ld	(de),a

	inc	c
	djnz	.lp1

	ld	a,$24		; 0x4000-0x7fff̓ǂݏoORAM
	out	($62),a
	add	a,2
	out	($63),a

	pop	hl
	pop	de
	pop	bc
	pop	af
	ret

;
; 8x8x3v[L\iԐFwij
;
; HLFLN^f[^AhX
; DEFVRAMAhXi0xd400`0xd7ffj
;
Draw_8x8x3_red:
	push	af
	push	bc
	push	de
	push	hl

	res	3,h
	set	2,h

	push	hl		; VRAMAhX

	ld	e,(hl)
	set	3,h
	ld	a,(hl)
	and	$40
	rlca
	rlca
	ld	d,a
	ex	de,hl

	add	hl,hl	; x2
	add	hl,hl	; x4
	add	hl,hl	; x8
	add	hl,hl	; x16
	add	hl,hl	; x32
	ld	de,$4000
	add	hl,de	; HLFLN^AhXi0x4000`j

	pop	de	; VRAMAhX


	push	hl
	call	CALC_XY
	pop	hl

	ld	a,$08		; 0x4000-0x7fff̓ǂݏoRAM0x8000-0xbfff
	out	($62),a
	add	a,2
	out	($63),a

	ld	b,8
	ld	(.xpos+1),de
.lp1:
.xpos:	ld	de,$0000
	ld	a,c
	out	($ce),a

	REPT	4
	ld	a,(hl)
	and	$07
	jp	nz,.n1
	ld	a,$02		; 
.n1:	or	$08
	ld	(de),a
	ld	a,(hl)
	inc	hl
	inc	e
	rlca
	rlca
	rlca
	rlca
	and	$07
	jp	nz,.n2
	ld	a,$02		; 
.n2:	or	$08
	ld	(de),a
	inc	e
	ENDM

	inc	c
	djnz	.lp1

	ld	a,$24		; 0x4000-0x7fff̓ǂݏoORAM
	out	($62),a
	add	a,2
	out	($63),a

	pop	hl
	pop	de
	pop	bc
	pop	af
	ret

;
; 8x8x1v[L\
;
; HLFLN^f[^AhX
; DEFVRAMAhXi0xd000`0xd3ffj
; A F`Fi0x08`0x0fj
;
Draw_8x8x1:
	ld	(.col+1),a

	push	hl
	call	CALC_XY
	pop	hl

	ld	a,$d0		; 0x4000-0x7fff̓ǂݏoCG-ROM0x0000-0x3fff
	out	($62),a
	add	a,2
	out	($63),a

	ex	de,hl
	ld	(.xpos+1),hl

	ld	b,8
.lp1:
.xpos:	ld	hl,$0000
	push	bc
	ld	a,c
	out	($ce),a

.col:	ld	bc,$0800
	ld	a,(de)
	inc	de

	REPT	7
	rlca
	ld	(hl),b		; 
	jr	nc,.b1
	ld	(hl),c		; `F
.b1:	inc	l
	ENDM

	rlca
	ld	(hl),b		; 
	jr	nc,.b8
	ld	(hl),c		; `F
.b8:

	pop	bc
	inc	c
	djnz	.lp1

	ld	a,$24		; 0x4000-0x7fff̓ǂݏoORAM
	out	($62),a
	add	a,2
	out	($63),a

	ret

;
; 8x8L
;
; HLFVRAMAhXi0xd400`0xd7ff / 0xd000`0xd3ffj
; B F`F
;
Erase_8x8:
	ex	de,hl
	call	CALC_XY
	ex	de,hl

	ld	a,c	; YW
	ld	e,l	; XWʁiۑpj
	ld	c,b	; `F
	ld	b,8
.lp1:
	ld	l,e
	out	($ce),a

	REPT	7
	ld	(hl),c
	inc	l
	ENDM

	ld	(hl),c

	inc	a
	djnz	.lp1

	pop	hl
	pop	de
	pop	bc
	pop	af
	ret

;
; Ji\
; HLFVRAMAhXi0xd000`0xd3ffj
;
PUTKANA:
	push	af
	push	bc
	push	de
	push	hl

	push	hl		; VRAMAhX
	ld	l,(hl)
	ld	h,0
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,hl		; x8
	add	hl,hl		; x16
	ld	de,$5000
	add	hl,de
	pop	de		; VRAMAhX

	ld	a,$0c		; 
	call	Draw_8x8x1

	pop	hl
	pop	de
	pop	bc
	pop	af
	ret

;
; VRAMAhXXYWZo
;
; DEFVRAMAhXi0xd400`0xd7ff / 0xd000`0xd3ffj
;
; RETURN
; DEFXW
; C FYW
;
CALC_XY:
	ld	l,e
	ld	a,d
	and	$03
	ld	h,a

	ld	c,$ff
	ld	de,40
.lp1:
	sbc	hl,de
	inc	c
	jr	nc,.lp1
	add	hl,de

	add	hl,hl	; x2
	add	hl,hl	; x4
	add	hl,hl	; x8
	ex	de,hl

	sla	c	; x2
	sla	c	; x4
	sla	c	; x8

	ret


;------------------------------------------------------------------------------
; SOUND TEhĐ
; IN :	HL =  (f = 1 / HL * 13us)
;	BC = Đ钷
;
;       1 / (HL*13us)
;  = 1MHz / (HL*13)
;  = 2MHz / (HL*26)
;  = 2MHz / ( (HL*26/16) *16)
;  = 2MHz / ( (HL*13/ 8) *16)
;
; HL 13{Ă16rbgȉȂ̂ŁA|Žӂ͋CɂȂ
;------------------------------------------------------------------------------
Sound:
	push	hl

;	ld	e,l
;	ld	d,h
;	add	hl,hl		; x2
;	add	hl,de		; x3
;	add	hl,hl		; x6
;	add	hl,hl		; x12
;	add	hl,de		; x13

	ld	e,l
	ld	d,h
	add	hl,hl		; x2
	add	hl,de		; x3
	add	hl,hl		; x6
	add	hl,de		; x7
	add	hl,hl		; x14

	srl	h
	rr	l		; /2
	srl	h
	rr	l		; /4
	srl	h
	rr	l		; /8

	ld	a,0
	out	($a0),a
	ld	a,l		; `lA̎gݒ肷iʁj
	out	($a1),a
	ld	a,1
	out	($a0),a
	ld	a,h		; `lA̎gݒ肷iʁj
	out	($a1),a

	pop	hl

	ld	a,8
	out	($a0),a
	ld	a,15		; `lẢʂőɂ
	out	($a1),a

.lp2:	LD	D, H
	LD	E, L
.lp1:	DEC	DE		;  6+1 ( 7) 13us̃fBC
	LD	A, D		;  4+1 (12)
	OR	E		;  4+1 (17)
	ld	a,0		;  7+1 (25)
	ld	a,0		;  7+1 (33)
	JR	NZ, .lp1	; 12+1 (46)
	DEC	BC
	LD	A, B
	OR	C
	JR	NZ, .lp2

	ld	a,8
	out	($a0),a
	ld	a,0		; `lẢʂOɂ
	out	($a1),a

	RET

;------------------------------------------------------------------------------
; WAIT 1msPʂ̃EFCg
; IN :	HL = EFCg̒(ms)
;------------------------------------------------------------------------------
Wait:

.lp1:
	ld	b,95		; 4+1		/ 5
.lp2:
	push	hl		; 10+1	/ 11
	pop	hl		; 11+1	/ 23
	djnz	.lp2		; 13+1	/ 37 -> 3515

	dec	hl		; 6+1		/ 12
	ld	a,h		; 4+1		/ 17
	or	l		; 4+1		/ 22
	jr	nz,.lp1		; 12+1		/ 35

	RET

;
; Q[L[͓ǂݏo
;
GAMEKEY:
	ld	a,(GAMEDATA)
	ret

;
; L[
;
; Q[L[̗͂オ肩AL[f[^o͂
;
; SPCF0x20
;  F0x14
;  F0x13
;
INKEY:
	push	bc
;	ld	a,(KEYDATA)	; "0" STOP SFT SPC E
	ld	a,(GAMEDATA)	; "0" STOP SFT SPC E

	ld	b,$20		; SPC
	bit	4,a
	jr	nz,.end

	ld	b,$14		; 
	bit	2,a
	jr	nz,.end

	ld	b,$13		; E
	bit	3,a
	jr	nz,.end

	ld	b,$00
.end:
	ld	a,b
	pop	bc
	ret

	org	$b7ff
	db	$ff

end
