;
; Holy KNIGHTNp
;

	relaxed on

	include	"pc60_hira.asm"

J_GAMESTART	equ	$b030

Disk_Routine	equ	$c400
Disk_Init	equ	Disk60_Entry+0
Disk_Load	equ	Disk60_Entry+3
Disk_Change1DD	equ	Disk60_Entry+12

	org	$c000

;
; Track#0 Sector#1`
;
	db	"IPL"		; +0
	jp	START		; +3

;
; ZN^ǂݍ݁iROM[`gpj
;
READ_NSEC:			; +6
	push	af
	xor	a
	ld	($ed66),a	; hCuԍ-1
	pop	af
.loop:
	push	af
.retry:
	ld	a,$01
	or	a
	push	bc
	push	de
	call	$0198		; ZN^ǂݍ
	pop	de
	pop	bc
	jr	c,.retry
	inc	d		; i[AhXi߂
	inc	c		; ZN^i߂
	ld	a,c
	cp	17
	jr	c,.next		; ZN^16ȉȂWv
	ld	c,1		; ZN^Pɂ
	inc	b		; gbNi߂
.next:
	pop	af
	dec	a
	jr	nz,.loop
	ret

START:
	ld	sp,$d000

	ld	a,$ee		; 40x20
	out	($c8),a
	ld	($ed1d),a	; ʕύXi|[g0xc8j
	ld	a,$ff		; 40x20
	out	($c1),a
	ld	($ed1c),a	; ʕύXi|[g0xc1j
	ld	a,$00		; eLXgVRAM0x0000`
	out	($c9),a
	ld	($ed1e),a	; \ʁi|[g0xc9j

	ld	bc,$0002	; Breg:gbNԍACreg:ZN^ԍ
	ld	de,$c100	; i[AhX
	ld	a,$03		; ǂݍރZN^
	call	READ_NSEC

	ld	hl,$0000
	call	CURCLS		; ʃNA

	call	RAMCHECK	; OtRAM`FbN
	ld	(RAMSIZE),a
	cp	$04		; 64KȂNG
	jp	c,RAMNG

	ld	de,VER_MSG
	call	PNT_MSG

	ld	de,RAM_MSG
	call	PNT_MSG

	ld	a,(RAMSIZE)
.rm2:
	rrca
	jr	c,.rm1
	ld	hl,6
	add	hl,de
	ex	de,hl
	jr	.rm2

.rm1:
	call	PNT_MSG

	ld	de,CR_MSG
	call	PNT_MSG

	ld	hl,2500
	call	W_TIME

;
; fBXNǂݏo[`[h
;
	ld	bc,$0005	; BregFgbNԍACregFZN^ԍihCupǂݏo[`j
	ld	a,($ed5a)	; bit7`0 = Ot#2A#1A#2A#1A"0000"
	bit	4,a
	jr	nz,.fd_in
	ld	bc,$0007	; BregFgbNԍACregFZN^ԍiOthCupǂݏo[`j
.fd_in:
	ld	de,Disk_Routine	; i[擪AhX
	ld	a,$02		; ǂݍރZN^
	call	READ_NSEC

;
; 0x0000-0x1fffRAMiVRAMjɂ
; 0x2000-0xbfffORAMɂ
;
	di
	ld	a,$00
	out	($60),a
	out	($68),a
	ld	a,$22
	out	($61),a
	out	($69),a
	add	a,2
	out	($62),a
	out	($6a),a
	add	a,2
	out	($63),a
	out	($6b),a
	add	a,2
	out	($64),a
	out	($6c),a
	add	a,2
	out	($65),a
	out	($6d),a

;
; fBXN[`̏
;
	ld	d,$00
	call	Disk_Init
	jp	c,DISKNG

	ld	d,$00
	call	Disk_Change1DD
	jp	c,DISKNG

;
; Kvȃt@Cǂݍ
;
	ld	de,LOADING_MSG
	call	PNT_MSG

	ld	de,BIOSLD_MSG
	call	PNT_MSG
	ld	de,$0101	; Dreg:gbNԍAEreg:ZN^ԍ
	ld	hl,$b000	; i[AhX
	ld	bc,$0800	; ǂݍރZN^^hCuԍ
	call	Disk_Load
	jp	c,DISKNG

	ld	de,MAINPROGLD_MSG
	call	PNT_MSG
	ld	de,$0201	; Dreg:gbNԍAEreg:ZN^ԍ
	ld	hl,$2c00	; i[AhX
	ld	bc,$7300	; ǂݍރZN^^hCuԍ
	call	Disk_Load
	jp	c,DISKNG

		; 0x4000-0x7fffRAM0x8000-0xbfffɂ
		;
	ld	a,$08
	out	($62),a
	out	($6a),a
	add	a,2
	out	($63),a
	out	($6b),a

	ld	de,CHARALD_MSG
	call	PNT_MSG
	ld	de,$0a01	; Dreg:gbNԍAEreg:ZN^ԍ
	ld	hl,$4000	; i[AhX
	ld	bc,$4000	; ǂݍރZN^^hCuԍ
	call	Disk_Load
	jp	c,DISKNG

	ld	de,MENDATLD_MSG
	call	PNT_MSG
	ld	de,$0e01	; Dreg:gbNԍAEreg:ZN^ԍ
	ld	hl,$d000	; i[AhX
	ld	bc,$3000	; ǂݍރZN^^hCuԍ
	call	Disk_Load
	jp	c,DISKNG

	ld	de,MUSICDATLD_MSG
	call	PNT_MSG
	ld	de,$1101	; Dreg:gbNԍAEreg:ZN^ԍ
	ld	hl,$c900	; i[AhX
	ld	bc,$0400	; ǂݍރZN^^hCuԍ
	call	Disk_Load
	jp	c,DISKNG

		; 0x0000-0x1fffRAMiVRAMjɂ
		; 0x2000-0xbfffORAMɂ
		;
	ld	a,$00
	out	($60),a
	out	($68),a
	ld	a,$22
	out	($61),a
	out	($69),a
	add	a,2
	out	($62),a
	out	($6a),a
	add	a,2
	out	($63),a
	out	($6b),a
	add	a,2
	out	($64),a
	out	($6c),a
	add	a,2
	out	($65),a
	out	($6d),a

;
; ݒȂ
;
	call	INITOPN

	ld	a,$02
	out	($93),a		; ʂ

	ld	a,$fb		; CSS3-1=011
	out	($c0),a

	ld	a,$fb		; 320x200 OtBbN
	out	($c1),a

	ld	a,$e2		; rbg}bv[hɐݒ
	out	($c8),a

	ld	bc,$07c9
	xor	a
.outlp2:
	out	(c),a
				; 0xC9:VRAM}bv̐ݒ
				; 0xCA:XN[XW̐ݒ
				; 0xCB:XN[XW̐ݒ
				; 0xCC:XN[YW̐ݒ
				; 0xCD:XN[YW̐ݒ
				; 0xCE:YWiʁj̐ݒ
				; 0xCF:YWiʁj̐ݒ
	inc	c
	djnz	.outlp2

	call	GCLS		; OtBbNʃNA

	ld	a,$03
	out	($93),a		; ʂ\

	jp	J_GAMESTART

;
; OPN
;
INITOPN:
	ld	de,$07bf	; ~LT[FSďo͂Ȃ
	call	OUTOPN

	ld	b,3
	ld	de,$0800	; `l``b̉
.lp1:	call	OUTOPN
	inc	d
	djnz	.lp1

	ld	b,3
	ld	de,$2800	; S`lL[It
.lp2:	call	OUTOPN
	inc	e
	djnz	.lp2
	ret

;
; OPNɏo͂
; DFAhX
; EFf[^
;
OUTOPN:
	ld	a,d
	out	($a0),a

.lp1:	in	a,($a3)
	rlca
	jr	c,.lp1

	ld	a,e
	out	($a1),a

.lp2:	in	a,($a3)
	rlca
	jr	c,.lp2

	ret

;
; ԑ҂i 2ms ~ HLj
;
W_TIME:
.lp1:	ld	a,$78
.lp2:	dec	a
	jr	nz,.lp2

	dec	hl
	ld	a,h
	or	l
	jr	nz,.lp1
	ret

;
; `FbNƐݒ
; RETURN
; AFORAMoCgi16KPʁj
;
RAMCHECK:
	push	bc
	push	de
	push	hl
	di

	ld	a,$22		; 0x2000`0x3fff̃̓ǂݏORAM
	out	($61),a
	out	($69),a
	ld	a,$26		; 0x6000`0x7fff̃̓ǂݏORAM
	out	($63),a
	out	($6b),a
	ld	a,$2e		; 0xe000`0xffff̃̓ǂݏORAM
	out	($67),a
	out	($6f),a

	call	RAMCHECK_SUB

	ld	l,$40+$00	; mJ[gbW̃Zbg#0oN#0-7ɐݒ
	ld	bc,$0830
.lp1:
	out	(c),l
	inc	c
	inc	l
	djnz	.lp1

	ld	a,$fa		; 0x2000`0x3fff̃̓ǂݏoN66SR-BASICɖ߂
	out	($61),a
	ld	a,$fe		; 0x6000`0x7fff̃̓ǂݏoN66SR-BASICɖ߂
	out	($63),a

	ld	a,$02		; 0x2000`0x3fff݂̃̏RAMɖ߂
	out	($69),a
	ld	a,$06		; 0x6000`0x7fff݂̃̏RAMɖ߂
	out	($6b),a
	ld	a,$0e		; 0xe000`0xffff̃̓ǂݏRAMɖ߂
	out	($67),a
	out	($6f),a

	ld	a,h
	ei
	pop	hl
	pop	de
	pop	bc
	or	a
	ret

;
; `FbNƐݒ
;
RAMCHECK_SUB:

		;
		; mJ[gbWmkIÎꂼ̃ZbgɃf[^
		; 0x0000-0xFFFFFRAM#1Zbg#3oN#8-15
		; 0x0000-0xFFFFFRAM#1Zbg#3oN#7-0
		; 0x0000-0xFFFFFRAM#1Zbg#2oN#8-15
		; 0x0000-0xFFFFFRAM#1Zbg#2oN#7-0
		; 0x0000-0xFFFFFRAM#1Zbg#1oN#8-15
		; 0x0000-0xFFFFFRAM#1Zbg#1oN#7-0
		; 0x0000-0xFFFFFRAM#1Zbg#0oN#8-15
		; 0x0000-0xFFFFFRAM#1Zbg#0oN#7-0
		; 0x0000-0xFFFFFRAM#0Zbg#3oN#8-15
		; 0x0000-0xFFFFFRAM#0Zbg#3oN#7-0
		; 0x0000-0xFFFFFRAM#0Zbg#2oN#8-15
		; 0x0000-0xFFFFFRAM#0Zbg#2oN#7-0
		; 0x0000-0xFFFFFRAM#0Zbg#1oN#8-15
		; 0x0000-0xFFFFFRAM#0Zbg#1oN#7-0
		; 0x0000-0xFFFFFRAM#0Zbg#0oN#8-15
		; 0x0000-0xFFFFFRAM#0Zbg#0oN#7-0
		;

	ld	l,$40+$40+$38+7
	ld	b,16
.lp3:
	push	bc

	ld	bc,$0837
.lp2:
	out	(c),l
	dec	c
	dec	l
	djnz	.lp2

	ld	de,$ffff

	ld	a,l
	xor	$55
	ld	(de),a
	ld	a,l
	xor	$db
	dec	de
	ld	(de),a

	ld	de,$7fff

	ld	a,l
	cpl			; xor	$ff
	ld	(de),a
	ld	a,l
	xor	$c3
	dec	de
	ld	(de),a

	ld	de,$3fff

	ld	a,l
				; xor	$00
	ld	(de),a
	ld	a,l
	xor	$aa
	dec	de
	ld	(de),a

	pop	bc
	djnz	.lp3

		;
		; mJ[gbWmkIIɏf[^Ԃɓǂݏoă`FbN
		; 0x0000-0xFFFFFRAM#0Zbg#0oN#7-0
		; 0x0000-0xFFFFFRAM#0Zbg#0oN#8-15
		; 0x0000-0xFFFFFRAM#0Zbg#1oN#7-0
		; 0x0000-0xFFFFFRAM#0Zbg#1oN#8-15
		; 0x0000-0xFFFFFRAM#0Zbg#2oN#7-0
		; 0x0000-0xFFFFFRAM#0Zbg#2oN#8-15
		; 0x0000-0xFFFFFRAM#0Zbg#3oN#7-0
		; 0x0000-0xFFFFFRAM#0Zbg#3oN#8-15
		; 0x0000-0xFFFFFRAM#1Zbg#0oN#7-0
		; 0x0000-0xFFFFFRAM#1Zbg#0oN#8-15
		; 0x0000-0xFFFFFRAM#1Zbg#1oN#7-0
		; 0x0000-0xFFFFFRAM#1Zbg#1oN#8-15
		; 0x0000-0xFFFFFRAM#1Zbg#2oN#7-0
		; 0x0000-0xFFFFFRAM#1Zbg#2oN#8-15
		; 0x0000-0xFFFFFRAM#1Zbg#3oN#7-0
		; 0x0000-0xFFFFFRAM#1Zbg#3oN#8-15
		;

	ld	h,0
	ld	l,$40+$00
	ld	a,16
.lp5:
	ex	af,af'

	ld	bc,$0830
.lp4:
	out	(c),l
	inc	c
	inc	l
	djnz	.lp4

	ld	a,l
	sub	$09
	ld	b,a

	ld	de,$3fff
	ld	a,(de)
				; xor	$00
	cp	b
	ret	nz		; RAMȂ/oNI

	dec	de
	ld	a,(de)
	xor	$aa
	cp	b
	ret	nz		; RAMȂ/oNI

	inc	h

	ld	de,$7fff
	ld	a,(de)
				; xor	$00
	cp	b
	jr	nz,.next1	; RAM<>16K

	dec	de
	ld	a,(de)
	xor	$aa
	cp	b
	ret	z		; RAM=16K
	jr	.ng

.next1:
	ld	a,(de)
	cpl			; xor	$ff
	cp	b
	jr	nz,.ng		; RAMȂ

	dec	de
	ld	a,(de)
	xor	$c3
	cp	b
	jr	nz,.ng		; RAMȂ

	inc	h

	ld	de,$ffff
	ld	a,(de)
	cpl			; xor	$ff
	cp	b
	jr	nz,.next2	; RAM<>32K

	dec	de
	ld	a,(de)
	xor	$c3
	cp	b
	ret	z		; RAM=32K
	jr	.ng

.next2:

	ld	a,(de)
	xor	$55
	cp	b
	jr	nz,.ng		; RAMȂ

	dec	de
	ld	a,(de)
	xor	$db
	cp	b
	jr	nz,.ng		; RAMȂ

	inc	h
	inc	h

	ex	af,af'
	dec	a
	jr	nz,.lp5

	ret

.ng:
	ld	h,0
	ret

;
; ʃNAiLN^j
; HLFy[W擪
;
CURCLS:
	ld	bc,40*25
.lp1:
	ld	(hl),$20
	inc	hl
	ld	(hl),$0f
	cpi
	jp	pe,.lp1
	ret

;
; OtBbNʃNA
;
GCLS:
	ld	c,$08
.lp2:
	out	($ce),a

	ld	hl,$0000
	ld	b,320/2
.lp1:
	ld	(hl),c
	inc	l
	ld	(hl),c
	inc	hl
	djnz	.lp1

	inc	a
	cp	204
	jr	nz,.lp2

	ret

;
; fBXNNG\
;
DISKNG:
	ld	de,DISKNG_MSG
	call	PNT_MSG
	jr	$

;
; RAM NG\
;
RAMNG:
	ld	de,RAMNG_MSG
	call	PNT_MSG
	jr	$

;
; \
;
PNT_MSG:
	push	bc
	ld	bc,(CUR_XY)
.lp1:
	ld	a,(de)
	inc	de
	or	a
	jr	z,.end
	cp	$0d
	jr	nz,.nom

	ld	c,0
	inc	b
	jr	.lp1
.nom:
	push	af
	push	bc

	ld	a,b
	add	a,a		; x2
	add	a,a		; x4
	add	a,b		; x5
	ld	l,a
	ld	h,0
	add	hl,hl		; x10
	add	hl,hl		; x20
	add	hl,hl		; x40
	add	hl,hl		; x80
	ld	b,$00		; VRAMy[Wݒ
	add	hl,bc

	pop	bc
	pop	af
	ld	(hl),a
	inc	c
	inc	c

	ld	a,c
	cp	80
	jr	c,.lp1
	ld	c,0
	inc	b
	jr	.lp1

.end:
	ld	(CUR_XY),bc
	pop	bc
	ret

CUR_XY:	dw	$0000

RAMSIZE:
	db	$00


VER_MSG:
	db	"Holy KNIGHT for P6 ver1.0",$0d,$0d,$00

DISKNG_MSG:
	db	"Disk error",$0d,$00

RAMNG_MSG:
	db	"64K ",H_i,H_si,"",H_yos,H_u,H_no,"RAM",H_ka," "
	db	H_hi,H_tu,H_yo,H_u,H_te,"",H_su,"",$0d,$00

RAM_MSG:
	db	"RAM:",$00
	db	"16K ",$0d,$00
	db	"32K ",$0d,$00
	db	"64K ",$0d,$00
	db	"128K",$0d,$00
	db	"256K",$0d,$00
	db	"512K",$0d,$00
	db	"1024K",$0d,$00

LOADING_MSG:
	db	"Loading...",$0d,$00
BIOSLD_MSG:
	db	"BIOS",$0d,$00
MAINPROGLD_MSG:
	db	"Main Program",$0d,$00
CHARALD_MSG:
	db	"Character",$0d,$00
MENDATLD_MSG:
	db	"Scene data",$0d,$00
MUSICDATLD_MSG:
	db	"Music data",$0d,$00

CR_MSG:
	db	$0d,$00


	org	$c400
;
; Track#0 Sector#5-6
;

	phase	Disk_Routine

	include	"disk66.z80"	; hCupǂݏo[`

	dephase

	org	$c600
;
; Track#0 Sector#7-8
;

	phase	Disk_Routine

	include	"disk.z80"	; OthCupǂݏo[`

	dephase


	org	$c7ff
	db	$ff


end

