/************************/
/* Kf[^ϊ */
/************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAXBUF	0x1000

void	fput4b(int,FILE *);
void	outheader(int,int,FILE *);

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		buff[MAXBUF];

	int		size;
	int		offset;

	int		c, i, cnt;
	int		a0, a1, fq;
	int		a0_p, a1_p, fq_p;

	float	fqk = (1.996750 * 2 / 3.579545);


	if (argc != 5) {
		fprintf(stderr, "Usage: convfreq infile outfile datanum offset\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	size = atoi(argv[3]);
	offset = atoi(argv[4]);

	cnt = 0;
	while ( (c = fgetc(infp)) != EOF) {
		buff[cnt] = c;
		cnt ++;
	}

	for (i = 0;i < size;i ++) {
		a0 = buff[offset+i*2+1];
		a1 = buff[offset+i*2+0];

		fq = (a0 & 0x0f) | ((a1 & 0x3f) << 4);
		fq_p = (int)(fq * fqk);
		fq_p = (fq_p & 0x0fff);

		a0_p = (a0 & 0xf0) | ( (fq_p & 0x0f00) >> 8);
		a1_p = ( (fq_p & 0x00fe) >> 1);

		buff[offset+i*2+1] = a0_p;
		buff[offset+i*2+0] = a1_p;
	}

	for (i = 0;i < cnt;i ++) {
		fputc(buff[i], outfp);
	}


	fclose(outfp);
	fclose(infp);

	return(0);
}
